
Redmine - Feature #9850

Differentiate shared versions in version-format custom field drop-downs by prepending its project

name

2011-12-21 03:32 - Mischa The Evil

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

Like the subject already implies, I'd suggest to differentiate available shared versions in version-format custom field drop-downs by

prepending its project name like it is already done for the target version attribute drop-downs. This way we can (also) distinct the

versions from eachother whenever there are duplicates.

Some screenshots of what I'm proposing:

This is how it is now:

 vcf_differenciation.jpg 

This is how it could look like (so we can distict the both 1.0's)

 tv_differenciation.jpg 

Related issues:

Related to Redmine - Feature #9851: Equalize the way how available shared ver... New

Related to Redmine - Feature #19965: values of custom fileds of version type ... Closed

Related to Redmine - Feature #23265: Group versions by status in version cust... Closed

Has duplicate Redmine - Feature #10926: Version custom field should display t... Closed

Has duplicate Redmine - Feature #14449: Versions custom field format Closed

History

#1 - 2011-12-21 03:32 - Mischa The Evil

- Description updated

#2 - 2011-12-22 23:22 - Mischa The Evil

- Subject changed from Differenciate available shared versions in version-format custom field drop-downs by prepending its project name to

Differentiate available shared versions in version-format custom field drop-downs by prepending its project name

- Description updated

Fixing ugly typos.

#3 - 2012-05-15 18:51 - Maher Gamal

Can we have this in an upcoming minor version ?

#4 - 2012-05-16 15:26 - Maher Gamal

The duplicate #10926 was marked as Candidate for the next minor version, can we mark this one as well to have it scheduled.

#5 - 2012-05-16 15:26 - Etienne Massip

- Target version set to Candidate for next minor release

#6 - 2013-01-21 10:14 - claude g

+1

#7 - 2013-01-27 05:33 - Mischa The Evil

Simple patch could work. In source:/trunk/app/models/custom_field.rb@11275#L99 change:

2025-05-01 1/3

https://www.redmine.org/issues/10926
https://www.redmine.org/projects/redmine/repository/svn/revisions/11275/entry/trunk/app/models/custom_field.rb#L99


-         obj.project.shared_versions.sort.collect {|u| [u.to_s, u.id.to_s]}

+         obj.project.shared_versions.sort.collect {|u| ["#{u.project.to_s} - #{u.to_s}", u.id.to_s]}

 to prepend "{project name} - " before the "{version name}".

This makes it possible to differentiate shared versions in version format custom field drop-downs.

#8 - 2013-01-27 17:30 - Mischa The Evil

Note: the patch in note-7 does not prepend project names to custom field values in the custom field column on the issue list. This is the same

behavior as currently implemented for the target version column. It might be better to change this also for (at least, shared) versions to distinct

versions from other projects from current project versions.

Such should follow a fix for this issue first, so it will be better to open a new issue for that. Also #9851 needs to be taken into account since it is related

in sense of how target-versions are displayed throughout the Redmine UI (now thinking of version#x links, roadmap, version views etc. also).

#9 - 2013-02-16 00:23 - Mischa The Evil

Mischa The Evil wrote:

Note: the patch in note-7 does not prepend project names to custom field values in the custom field column on the issue list. This is the same

behavior as currently implemented for the target version column. It might be better to change this also for (at least, shared) versions to distinct

versions from other projects from current project versions.

[...] Also #9851 needs to be taken into account since it is related in sense of how target-versions are displayed throughout the Redmine UI (now

thinking of version#x links, roadmap, version views etc. also).

 Follow-up on #9850-8 [note-8], extracted from (duplicate) issue #10926-5 [note-5]:

Actually, the project name is already prepended to shared versions displayed on the Roadmap view with or without using the Subprojects

selection in the right side-bar. This also applies to both the project- and global Gantt views but specifically not for:

the project Calendar view (since shared versions aren't displayed there anyways);

the Version view (since versions are always tied to a single project anyway);

the project- and global Issue list view columns and finally, I think,

the Redmine version links.

 Despite all the above: this issue is specifically about version-format custom field values and not the target versions.

Tested on Redmine 2.1.x / *.m.redmine.org.

#10 - 2013-07-13 00:32 - Mischa The Evil

- Related to Feature #14449: Versions custom field format  added

#11 - 2013-07-13 00:32 - Mischa The Evil

- Related to deleted (Feature #14449: Versions custom field format )

#12 - 2013-07-13 00:32 - Mischa The Evil

- Has duplicate Feature #14449: Versions custom field format  added

#13 - 2014-04-12 15:29 - Maicon Zucco

Hi,

How I change this in 2.5.1 version?

Thanks.

#14 - 2015-08-06 09:53 - Toshi MARUYAMA

- Related to Feature #19965: values of custom fileds of version type should be prefixed with or grouped by project name added

#15 - 2015-08-24 10:39 - Alexis Parent

+1

#16 - 2016-01-20 14:15 - Christophe Portier

+1

#17 - 2016-02-05 15:12 - Maicon Zucco
I found a way to change on 2.5.3:

--- from_file

+++ lib/redmine/field_format.rb

@@ -690,7 +690,8 @@

               scope = scope.where(:status => statuses.map(&:to_s))

             end

           end

-          scope.sort.collect {|u| [u.to_s, u.id.to_s]}

+          scope.sort_by! {|u| ["#{u.project.to_s} - #{u.to_s}", u.id.to_s]}

+          scope.collect {|u| ["#{u.project.to_s} - #{u.to_s}", u.id.to_s]}

         else

           []

         end

#18 - 2017-01-18 03:03 - Mischa The Evil

- Related to Feature #23265: Group versions by status in version custom field filter added

#19 - 2017-01-18 03:03 - Mischa The Evil

- Status changed from New to Closed

- Target version deleted (Candidate for next minor release)

The initial issue (indistinguishable shared versions in version-format custom field drop-downs) has been fixed by r16194 for #23265.

#20 - 2017-04-16 09:49 - Mischa The Evil

- Subject changed from Differentiate available shared versions in version-format custom field drop-downs by prepending its project name to

Differentiate shared versions in version-format custom field drop-downs by prepending its project name

- Target version set to 3.4.0

- Resolution set to Fixed

Setting target version to 3.4.0 because I think that this fixed issue should appear on the changelog, in order to let everyone know about this

long-awaited improvement.

#21 - 2018-01-03 07:32 - Edgars Batna

I'm on 3.4.3.stable and I don't see where this is fixed. If I add a Multiselection Dropdown Version Version Custom Field, then the list shows all sorts of

Versions without Project names.

Could it be that it was only fixed for Filters and Roadmap? If that's the case, then all these Tickets might have been closed in haste.

#22 - 2018-01-03 07:49 - Edgars Batna

P.S.

I'm talking about custom version fields when creating new tickets or versions.

#23 - 2018-01-25 15:19 - Toshi MARUYAMA

Edgars Batna wrote:

P.S.

I'm talking about custom version fields when creating new tickets or versions.

 Indeed.

I think it is covered in #9851 and #15902.
